c4wled.sh/wled

78 lines
1.9 KiB
Text
Raw Normal View History

2024-08-02 08:18:32 +02:00
#!/bin/sh
#
# Simpel command line tool to turn predefined wled instances on/off or switch
# presets.
#
# Author: Shy
# License: CC0
2024-08-02 20:47:17 +02:00
CURL_FLAGS="--silent --show-error --fail --ipv4 --max-filesize 64K"
2024-08-02 08:18:32 +02:00
print_usage() {
2024-08-02 18:11:50 +02:00
echo "Usage: $0 f(nordcenter)|w(ohnzimmer) on|off|1-17|list"
2024-08-02 08:18:32 +02:00
}
if test $# -ne 2; then
print_usage
exit 0
fi
# Parse host argument.
case "$1" in
f|fnordcenter)
wled_host='wled-fnordcenter.local'
;;
w|wohnzimmer)
wled_host='wled-wohnzimmer.local'
;;
*)
echo "Error: unknown host \"$1\"." >&2
print_usage
exit 1
;;
esac
# Parse and execute command argument.
case "$2" in
on)
2024-08-02 20:47:17 +02:00
api_resp=$(curl $CURL_FLAGS --json '{"on":true}' "http://$wled_host/json")
2024-08-02 08:18:32 +02:00
;;
off)
2024-08-02 20:47:17 +02:00
api_resp=$(curl $CURL_FLAGS --json '{"on":false}' "http://$wled_host/json")
2024-08-02 08:18:32 +02:00
;;
[1-9]|[1-9][0-7])
2024-08-02 20:47:17 +02:00
api_resp=$(curl $CURL_FLAGS --json "{'on':true,'ps':$2}" "http://$wled_host/json")
2024-08-02 08:18:32 +02:00
;;
2024-08-02 17:07:08 +02:00
l|list)
echo "Presets on $wled_host:"
2024-08-02 20:47:17 +02:00
curl $CURL_FLAGS "http://$wled_host/presets.json" | \
2024-08-03 20:55:59 +02:00
# Split into lines - one line per preset. Append final newline.
sed --sandbox 's/"\(1\?[0-9]\)"/\n"\1"/g; $a\' | \
# Extract number and name of every preset.
sed --sandbox -n 's/^"\(1\?[0-9]\)":.*"n":"\([[:print:]]*\)".*$/\1: \2/p'
2024-08-02 17:07:08 +02:00
exit $?
;;
2024-08-02 08:18:32 +02:00
dump)
2024-08-02 20:47:17 +02:00
curl $CURL_FLAGS -w '\n' "http://$wled_host/json"
2024-08-02 08:18:32 +02:00
exit 0
;;
*)
echo "Error: unknown command \"$2\"." >&2
print_usage
exit 1
;;
esac
2024-08-02 08:39:05 +02:00
curl_exit=$?
if test $curl_exit -ne 0; then
echo "Error: curl exited with exit code $curl_exit."
exit 1
fi
2024-08-02 08:18:32 +02:00
# Check API responce. Should be {"success":true}.
if test "$(echo -n "$api_resp"|tr -c -d '[:alpha:]')" != 'successtrue'; then
echo "Error: unexpected responce from WLED API." >&2
exit 1
fi